#include <fcntl.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>

int if_diff_jours_(int *date_in_1, int *date_in_2)
{
 struct tm time1;
 struct tm time2;
 long date1;
 long date2;
 int res_jours=0.;
//
// 1990
 time1.tm_year = *date_in_1/10000 - 1900;
 time1.tm_mon = *date_in_1/100 - (*date_in_1/10000) * 100  - 1;
 time1.tm_mday = *date_in_1 - (time1.tm_mon+1)*100 - (*date_in_1/10000) * 10000 ;
 time1.tm_hour = 13;
 time1.tm_min = 0;
 time1.tm_sec = 0;
 time1.tm_isdst = -1;
 date1=mktime(&time1);
// printf ("date = %d\n", date1);
// date input
 time2.tm_year = *date_in_2/10000 - 1900;
 time2.tm_mon = *date_in_2/100 - (*date_in_2/10000) * 100  - 1;
 time2.tm_mday = *date_in_2 - (time2.tm_mon+1)*100 - (*date_in_2/10000) * 10000 ;
 time2.tm_hour = 1;
 time2.tm_min = 0;
 time2.tm_sec = 0;
 time2.tm_isdst = -1;
 date2=mktime(&time2);
// calcul secondes
 res_jours=(date1-date2)/86400.;
// printf ("res_jours = %d, %d, %d\n", date1, date2, res_jours);
 return(res_jours);
}

int if_diff_mois_(int *date_in_1, int *date_in_2)
{
 int res_mois=0.;
 res_mois=(*date_in_1/100 - *date_in_2/100)*12 + *date_in_1 - (*date_in_1/100)*100 - *date_in_2 + (*date_in_2/100)*100;
 return(res_mois);
}

int if_diff_an_(int *an_in_1, int *an_in_2)
{
 int res_an=0.;
 res_an = *an_in_1 - *an_in_2;
 return(res_an);
}

int if_diff_jours_noleap_(int *date_in_1, int *date_in_2)
{
 struct tm time1;
 struct tm time2;
 struct tm time_fev;
 long date1;
 long date2;
 long date_fev;
 int res_jours=0.;
//
// date input
 time2.tm_year = *date_in_2/10000 - 1900;
 time2.tm_mon = *date_in_2/100 - (*date_in_2/10000) * 100  - 1;
 time2.tm_mday = *date_in_2 - (time2.tm_mon+1)*100 - (*date_in_2/10000) * 10000 ;
 time2.tm_hour = 1;
 time2.tm_min = 0;
 time2.tm_sec = 0;
 time2.tm_isdst = -1;
 date2=mktime(&time2);
// 1990
 time1.tm_year = time2.tm_year;
 time1.tm_mon = *date_in_1/100 - (*date_in_1/10000) * 100  - 1;
 time1.tm_mday = *date_in_1 - (time1.tm_mon+1)*100 - (*date_in_1/10000) * 10000 ;
 time1.tm_hour = 13;
 time1.tm_min = 0;
 time1.tm_sec = 0;
 time1.tm_isdst = -1;
 date1=mktime(&time1);
// printf ("date = %d\n", date1);
// date fevrier
 time_fev.tm_year = time2.tm_year;
 time_fev.tm_mon = 2;
 time_fev.tm_mday = 1;
 time_fev.tm_hour = 13;
 time_fev.tm_min = 0;
 time_fev.tm_sec = 0;
 time_fev.tm_isdst = -1;
 date_fev=mktime(&time_fev);
// calcul secondes
 res_jours=(date1-date2)/86400.+365*(*date_in_1/10000 - *date_in_2/10000);
 if ( date_fev <= date1 && date_fev >= date2 )
   res_jours--;
// printf ("res_jours = %d, %d, %d\n", date1, date2, res_jours);
 return(res_jours);
}

